import { AItem, HasInTopic } from './AItem'
import * as logger from './log'
import { mqttHandler } from './MqttDispatcher'

export class SwitchOffAdaptor extends AItem implements HasInTopic {
    private inTopic: string
    private actionStateTopic: string
    
    constructor(floor: string, room: string, item: string) {
        super(floor, room, item)
        this.actionStateTopic = `${this.topicFirstPart}/state`
        this.inTopic = `${this.topicFirstPart}/in`
        this.subscribeTopics = [ this.inTopic ]
    }

    getInTopic() : string {
        return this.inTopic
    }


    processMessage(topic: string, payload: string) : void {
        if ((topic == this.inTopic) && (payload == 'SHORT')) {
            mqttHandler.send(this.actionStateTopic, 'OFF', true)
        }
    }
}


